fixes, logging, and better shellcheck conformance
[distro-setup] / switch-mail-host
index d0117af58203015ec87fe91594b9df7756621c84..f7d926c39b84481b0834f4a3a72e8f85280218c5 100644 (file)
@@ -26,7 +26,7 @@ on the internet. Email can wait.
 
 Note: Uses GNU getopt options parsing style
 EOF
-  exit $1
+  exit 0
 }
 
 script_name="${BASH_SOURCE[0]}"
@@ -45,10 +45,11 @@ err-cleanup() {
   fi
 }
 
-pre="${SSH_CLIENT:+$HOSTNAME} $script_name:"
+pre="$script_name:"
 m() { printf "$pre %s\n"  "$*"; "$@"; }
 e() { printf "$pre %s\n"  "$*"; }
 err() { echo "$pre ERROR: $*" >&2; }
+die() { printf "%s\n" "$*" >&2; echo "exiting with status 1" >&2; exit 1; }
 
 if [[ $EUID != 0 ]]; then
   err "requires running as root"
@@ -61,15 +62,25 @@ fi
 mail_only=false
 host2_only=false
 force=false
+force_arg=
 pull_reexec=false
 mp_args="-m /o,/a,/ar,/q,/qd,/qr"
+check_installed=false
 orig_args=("$@")
-temp=$(getopt -l force,pull-reexec,help aioh "$@") || usage 1
+if ! temp=$(getopt -l check-installed,force,pull-reexec,help afioh "$@"); then
+  err "args invalid. args=$*"
+fi
 eval set -- "$temp"
 while true; do
   case $1 in
     -a) snapshot_arg=resume ;;
-    --force) force=true ;;
+    --force|-f)
+      force=true
+      force_arg=-f
+      ;;
+    --check-installed)
+      check_installed=true
+      ;;
     -i) incremental_arg="-i" ;;
     # internal option for rerunning under newer old_host when doing pull
     --pull-reexec) pull_reexec=true;;
@@ -83,7 +94,9 @@ while true; do
 done
 
 
-(( $# == 2 )) || usage 1
+if (( $# != 2 )) && ! $check_installed; then
+  err expected 2 args, got $#
+fi
 
 if [[ ! $HOSTNAME ]]; then
   err "\$HOSTNAME is unset"
@@ -91,11 +104,17 @@ if [[ ! $HOSTNAME ]]; then
 fi
 
 uninstalled-file-die() {
-  err "uninstalled file $1. run install-my-scripts or rerun with -f"
-  exit 1
+  die "uninstalled file $1. run install-my-scripts or rerun with -f"
 }
 
-if ! $force; then
+
+source /a/bin/bash_unpublished/source-state
+
+direction=$1
+host=$2
+
+
+if ! $force && { $check_installed || [[ $direction == push ]]; } ; then
   install_bin_files=(
     mount-latest-subvol
     check-subvol-stale
@@ -110,12 +129,12 @@ if ! $force; then
   if ! diff -q /a/bin/errhandle/err /usr/local/lib/err; then
     uninstalled-file-die err
   fi
+  if $check_installed; then
+    exit 0
+  fi
 fi
 
-source /a/bin/bash_unpublished/source-state
 
-direction=$1
-host=$2
 case $direction in
   push)
     old_host=$HOSTNAME
@@ -136,21 +155,22 @@ case $direction in
     old_shell="ssh -F $HOME/.ssh/confighome root@$old_host"
     # tests ssh connection. crafted this to not need to do escape chars
     f=/a/bin/bash_unpublished/source-state
-    if ! old_info=($($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f")); then
+    if ! old_info=$($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f"); then
       echo "$pre: error: failed ssh. retrying failed $old_shell with -v for more info:"
       $old_shell -v hostname
       exit 1
     fi
-    old_hostname=${old_info[0]}
-    MAIL_HOST=${old_info[1]}
-    HOST2=${old_info[2]}
+    IFS=" " read -r old_hostname MAIL_HOST HOST2 <<<"$old_info"
 
     if ! $mail_only && ! $pull_reexec ; then
+      if ! $force; then
+        $old_shell switch-mail-host --check-installed
+      fi
       tmpf=$(mktemp)
       m scp -F $HOME/.ssh/confighome root@$old_host:/usr/local/bin/switch-mail-host $tmpf
       if ! diff -q $tmpf ${BASH_SOURCE[0]}; then
         e "found different version on old_host=$old_hostname, reexecing"
-        install -T $tmpf /usr/local/bin/switch-mail-host
+        install -T $tmpf /usr/local/bin/switch-mail-host
         m /usr/local/bin/switch-mail-host --pull-reexec "${orig_args[@]}"
         mexit 0
       fi
@@ -284,7 +304,7 @@ EOF
 
 
 e Running initial btrbk
-m btrbk-run -v $bbk_args $incremental_arg $mp_args $snapshot_arg || ret=$?
+m btrbk-run -v $bbk_args $force_arg $incremental_arg $mp_args $snapshot_arg || ret=$?
 if (( ret )); then
   err "failed initial btrbk"
   exit $ret
@@ -314,7 +334,7 @@ fi
 m $new_shell killall -q emacs ||:
 
 e Running main btrbk
-m btrbk-run -v --fast $bbk_args $incremental_arg -m /o || ret=$?
+m btrbk-run -v --fast $bbk_args $force_arg $incremental_arg -m /o || ret=$?
 if (( ret )); then
   bang="$(printf "$(tput setaf 5)█$(tput sgr0)%.0s" 1 2 3 4 5 6 7)"
   e $bang failed btrbk of /o. restoring old host as primary
@@ -323,7 +343,7 @@ if (( ret )); then
 fi
 
 # new system is usable at this point
-printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
+printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s $(eval echo "{1..${COLUMNS:-60}}")"
 echo
 
 # once I accidentally accepted incoming mail on old host. I used this script to copy over that mail: